ALTER table %PREFIX%domains ADD column dom_notes text NOT NULL after dom_enable_err_docs;
ALTER table %PREFIX%orders ADD column ord_invc_id int(11) NOT NULL DEFAULT 0 after ord_optfld_05;
CREATE table %PREFIX%clients_contacts (contacts_id int(11) NOT NULL auto_increment, contacts_cl_id int(11) NOT NULL DEFAULT 0, contacts_name_first varchar(20) NOT NULL, contacts_name_last varchar(20) NOT NULL, contacts_email varchar(50) NOT NULL, UNIQUE KEY contacts_id (contacts_id), KEY contacts_cl_id (contacts_cl_id)) Type=MyISAM;
CREATE table %PREFIX%reminders (overdue_id int(11) NOT NULL auto_increment, overdue_title varchar(50) NOT NULL, overdue_active char(1) NOT NULL DEFAULT '1', overdue_days tinyint(4) NOT NULL DEFAULT 10, overdue_subject varchar(150) NOT NULL, overdue_template text NOT NULL, overdue_cc_support tinyint(1) NOT NULL DEFAULT 0, UNIQUE KEY overdue_id (overdue_id)) Type=MyISAM;
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (1, '10 Days Overdue', '1', 10, 'Account Overdue', 'Hello $_MTP[to_name];\r\n\r\nWe realize that everyone gets busy and occasionally overlooks things.  Unfortunately, we appear to have been overlooked this time.\r\n\r\nThis email is an automated notification that your account is now ten days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  If you have already made payment arrangements, we thank you for your diligence and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (2, '20 Days Overdue', '1', 20, 'Account Seriously Overdue', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated notification that your account is now twenty days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take immediate action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  Failure to do so may result in additional collection steps and/or costs.  If you have already made payment arrangements, we thank you and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nCollection Department\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (3, '30 Days Overdue', '1', 30, 'Account Suspended', 'Hello $_MTP[to_name];\r\n\r\nThis email is an automated notification that your account is now thirty days overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nThis is a very serious situation, and your account has been suspended.  To have your account re-instated, you must pay your outstanding balance in full plus a re-instatement fee of $20, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  Failure to pay everything owed within the next 15 days WILL result in ALL of your website, database and email files being deleted FOREVER.\r\n\r\nIf you have already made payment arrangements, we thank you and apologize for this automated reminder.\r\n\r\n\r\nRespectfully Yours,\r\nCollection Manager\r\n$_MTP[Company_Name]', 1);
INSERT INTO %PREFIX%reminders (`overdue_id`, `overdue_title`, `overdue_active`, `overdue_days`, `overdue_subject`, `overdue_template`, `overdue_cc_support`) VALUES (4, '1 Day Overdue', '1', 1, 'A Gentle Reminder', 'Hello $_MTP[to_name];\r\n\r\nWe realize that everyone gets busy and occasionally overlooks things.  Unfortunately, we appear to have been overlooked this time.\r\n\r\nThis email is an automated notification that your account is now overdue, with an outstanding balance of $_MTP[cl_balance].  You may check the status of your account by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nWe ask that you take action to bring your account up-to-date, as specified in our <a href="$_MTP[_PKG_URL_BASE]/mod.php?mod=siteinfo&id=7" target="_new">Terms Of Service</a> page.  If you have already made payment arrangements, we thank you for your diligence and apologize for this automated reminder.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]', 1);
CREATE table %PREFIX%whois (whois_id int(11) NOT NULL auto_increment, whois_server varchar(100) NOT NULL, whois_nomatch varchar(15) NOT NULL, whois_value varchar(20) NOT NULL, whois_display varchar(25) NOT NULL, whois_include tinyint(1) NOT NULL DEFAULT 1, whois_prod_id int(11) NOT NULL DEFAULT 0, whois_notes text NULL, UNIQUE KEY whois_id (whois_id)) Type=MyISAM;
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (1, 'whois.cira.ca', 'AVAIL', 'ca', '.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (2, 'whois.nic.biz', 'Not found', 'biz', '.biz', 0, 0, 'Must be registered to get WHOIS results for .biz');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (3, 'whois.cira.ca', 'AVAIL', 'ab.ca', '.ab.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (4, 'whois.cira.ca', 'AVAIL', 'bc.ca', '.bc.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (5, 'whois.cira.ca', 'AVAIL', 'mb.ca', '.mb.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (6, 'whois.cira.ca', 'AVAIL', 'nb.ca', '.nb.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (7, 'whois.cira.ca', 'AVAIL', 'ns.ca', '.ns.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (8, 'whois.cira.ca', 'AVAIL', 'nf.ca', '.nf.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (9, 'whois.cira.ca', 'AVAIL', 'on.ca', '.on.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (10, 'whois.cira.ca', 'AVAIL', 'pe.ca', '.pe.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (11, 'whois.cira.ca', 'AVAIL', 'pq.ca', '.pq.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (12, 'whois.cira.ca', 'AVAIL', 'sk.ca', '.sk.ca', 1, 0, 'Handles all .ca and PROV.ca domain registrations');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (13, 'whois.internic.net', 'no match', 'com net', '.com .net', 0, 0, 'Handles .com and .net domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (14, 'whois.internic.net', 'no match', 'com', '.com', 1, 0, 'Handles .com domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (15, 'whois.internic.net', 'no match', 'net', '.net', 1, 0, 'Handles .net domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (16, 'whois.opensrs.net', 'Not found', 'info', '.info', 1, 0, 'Handles .info domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (17, 'whois.publicinterestregistry.net', 'NOT FOUND', 'org', '.org', 1, 0, 'Handles .org domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (18, 'whois.dns.pl', 'does not exists', 'pl com.pl', '.pl .com.pl', 1, 0, 'Handles .pl and .com.pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (19, 'whois.dns.pl', 'does not exists', 'pl', '.pl', 1, 0, 'Handles .pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (20, 'whois.dns.pl', 'does not exists', 'com.pl', '.com.pl', 1, 0, 'Handles .com.pl domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (21, 'whois.nic.uk', 'No match', 'uk', '.uk', 1, 0, 'Handles .uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (22, 'whois.nic.uk', 'No match', 'co.uk org.uk me.uk', '.co.uk .org.uk .me.uk', 1, 0, 'Handles various combined .uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (23, 'whois.nic.uk', 'No match', 'co.uk', '.co.uk', 1, 0, 'Handles .co.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (24, 'whois.nic.uk', 'No match', 'org.uk', '.org.uk', 1, 0, 'Handles .org.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (25, 'whois.nic.uk', 'No match', 'me.uk', '.me.uk', 1, 0, 'Handles .me.uk domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (26, 'whois.nic.us', 'Not found:', 'us', '.us', 1, 0, 'Handles .us domains');
INSERT INTO %PREFIX%whois (`whois_id`, `whois_server`, `whois_nomatch`, `whois_value`, `whois_display`, `whois_include`, `whois_prod_id`, `whois_notes`) VALUES (27, 'whois.nic.cc', 'No Match', 'cc', '.cc', 1, 0, 'Handles .cc domains');
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES ('', 'module', 'whois', 'whois', 'WHOIS', 'WHOIS', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (`comp_id`, `comp_type`, `comp_name`, `comp_mod`, `comp_desc`, `comp_ptitle`, `comp_col_num`, `comp_isadmin`, `comp_isuser`, `comp_status`) VALUES ('', 'admin', 'cp_reminders', '', 'Control Panel: Setup overdue invoice auto-reminder', 'Reminders', 2, 0, 0, 1);
INSERT INTO %PREFIX%components (comp_id, comp_type, comp_name, comp_mod, comp_desc, comp_ptitle, comp_col_num, comp_isadmin, comp_isuser, comp_status) VALUES ('', 'admin', 'cp_whois', '1', 'Control Panel: WHOIS Lookups', 'Admin: WHOIS Lookups', 2, 1, 0, 1);
INSERT INTO %PREFIX%mail_templates (mt_id, mt_name, mt_text) VALUES ('', 'email_invoice_copy_singleline', 'Hello $_MTP[to_name],\r\n\r\nThis email is an automated notification that a new invoice has been issued against your account.\r\nThis email summarizes the invoice, and the original can be viewed and/or printed by clicking on the following link (requires login):\r\n$_MTP[invc_url]\r\n\r\nYou may have a prior debit or credit balance, in which case the amount we expect to receive from you is$_MTP[cl_balance].  You may login to the hosting control panel to see how this amount was determined.\r\n\r\nThank you for continuing to choose $_MTP[Company_Name] for your web service needs.\r\n\r\nRespectfully Yours,\r\nBilling Department\r\n$_MTP[Company_Name]\r\n\r\nINVOICE DETAILS:\r\n================\r\nInvoice ID:     $_MTP[invc_id]\r\nInvoice Date:   $_MTP[invc_ts]\r\nDate Due:       $_MTP[invc_ts_due]\r\nTerms:          $_MTP[invc_terms]\r\nDate Paid:      $_MTP[invc_ts_paid]\r\nInvoice Amount: $_MTP[invc_total_cost]\r\nBilling Cycle:  $_MTP[invc_bill_cycle]\r\nNotes: $_MTP[invc_pay_link]\r\n\r\nLine   Item         Description                                      Cost\r\n-------------------------------------------------------------------------\r\n$_MTP[iitems]\r\n-------------------------------------------------------------------------\r\nSubtotal:  $_MTP[invc_subtotal_cost]\r\n$_CCFG[INVC_TAX_01_LABEL]       $_MTP[invc_tax_01_amount] ($_MTP[invc_tax_01_percent]%)\r\n$_CCFG[INVC_TAX_02_LABEL]       $_MTP[invc_tax_02_amount] ($_MTP[invc_tax_02_percent]%)\r\n=================================\r\nTotal:     $_MTP[invc_total_cost]\r\n\r\nOur Tax Registration: $_MTP[Company_TaxNo]');
INSERT INTO %PREFIX%pages (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `pages_title`, `pages_code`, `pages_block_it`, `pages_status`, `pages_admin`, `pages_link_menu`, `pages_link_prev`, `pages_link_home`, `pages_link_next`) VALUES (2, 'Backup Disallowed', 3, 1, '%TIMESTAMP%', 'Backup Disallowed', 'Your attempt to backup the database has been disallowed, sorry. Either you are not an admin, or you used a POST/GET request from outside this website.', 1, 0, 0, 0, 0, 0, 0);
INSERT INTO %PREFIX%pages (`id`, `subject`, `topic_id`, `cat_id`, `time_stamp`, `pages_title`, `pages_code`, `pages_block_it`, `pages_status`, `pages_admin`, `pages_link_menu`, `pages_link_prev`, `pages_link_home`, `pages_link_next`) VALUES (3, 'Backup Completed', 3, 1, '%TIMESTAMP%', 'Backup Completed', 'The MySQL database backup procedure has completed. Depending on the backup option you chose, you will now have one of the following:<ul>\r\n<li>A MySQL dump file of the database on your computer, or</li>\r\n<li>A MySQL dump of the database in a directory on your webserver, or</li>\r\n<li>An email message with a MySQL dump of the database attached.</li>\r\n</ul>', 1, 0, 0, 0, 0, 0, 0);
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'domains', 'B', 'MATCH_CP_LOGIN_TO_ACCOUNT', 'Domain CP/FTP Match FTP Password To phpCOIN', '0', 'If "No", a random password for FTP will be generated by phpCOIN. If "Yes", the FTP password created by phpCOIN will match the username and password entered by the client for accessing phpCOIN. This means that you will know the u/p for account creation with cPanel, etc., but it is a security risk because the info is stored in the clear in the database');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'B', 'SHOW_PAYMENT_METHOD', 'Show Payment Method On Order Form', '0', 'If "Yes", allows client to select payment method from a drop-down list of vendors. If "No", hides the list and defaults to vendor_id 1. Note that if set to "No", this will also hide the "Optional Payment" field on the COR, regardless of whether it was turned on or not, and it will hide the "vendors" sections throughout the program.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'R', 'DOMAIN_SETUP_FEE', 'Add $xxx.yy to Order As Domain Setup Fee', '0', 'Any amount here other than zero will be added to the price of the product ordered as a domain setup fee, and the words " (plus setup fee)" will be appended to the item description on the order IF the mrwhois module "Order" link was clicked.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'R', 'ORDER_SETUP_FEE', 'Add $xxx.yy to Order As Order Setup Fee', '0', 'Any amount here other than zero will be added to the price of the product ordered as a setup fee, and the words " (plus setup fee)" will be appended to the item description on the order.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'invoices', 'B', 'PRICES_INCLUDE_TAXES', 'Invoice Taxes Are Included In Price', '0', 'If "No", phpCOIN will add applicable taxes to items on invoices. If "Yes", phpCOIN assumes that the prices include tax. In that event, taxes will be removed from the items and then recalculated, so the invoice can show the amount of taxes included in the prices.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'helpdesk', 'B', 'HELPDESK_ADMIN_CAN_ADD', 'Admin Can Enter New Support Tickets', '1', 'If "Yes", an administrator can enter a new support ticket on behalf of a client. If "No", only a client can enter a new support ticket.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'invoices', 'B', 'SINGLE_LINE_EMAIL_INVOICE_ITEMS', 'Single-line per item for email', '1', 'Set each item on an emailed invoice to be single-line like a paper invoice, or use default multi-line layout.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'user', 'package', 'S', 'CO_INFO_10_TAXNO', 'Company Info 10: Tax Number', '89910 3592', 'If you charge taxes and require that your tax registration number appear on invoices, etc., enter it here');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'package', 'I', 'USE_LOGIN_MENUBOX', 'Use Login Menu Box', 'o', 'If "Left Column", a login/logoff box will be displayed in the left column before any menus and the logon/logoff button in the header will be disabled. If "Right Column", a login/logoff box will be displayed in the right column before any menus and the logon/logoff button in the header will be disabled. If "None", phpCOIN defaults to normal operation. Make sure that if "Yes", then Admin -> Parameters -> Themes -> Disable Menu Columns (Left / Right) is also set to "No"');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'invoices', 'B', 'INVC_AUTO_REMINDERS_ENABLE', 'Invoice Overdue- Autosend overdue reminders', '1', 'If "Yes", phpCOIN will auto-send the specified email message on the specified overdue day(s). If "No", you must manually remind your customers that they are overdue. You may setup as many event-dates and templates as you need.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'S', 'WHOIS_AFFILIATE_LINK', 'Registrar Affiliate Link', 'http://www.123-reg.co.uk/affiliate.cgi?id=AF8763', 'If you are an affiliate of a domain registrar and wish to use an affiliate link to register domains, enter the URL of the link here.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'B', 'WHOIS_EXT_LIST', 'Show Extensions DropDown List', '1', '"Yes" will show allowable domain extensions as a drop-down list. "No" will show the list as radio buttons.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'B', 'WHOIS_DETAILS_NEW', 'Show Domain Details In New Window', '1', '"Yes" will show details of registered domain in new "popup" window, "No" will use current window.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'B', 'WHOIS_INSTRUCTIONS_SHORT', 'Show Short Instructions', '0', '"Yes" will show abbreviated domain selection instructions to surfers, "No" will show the long instructions.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'I', 'WHOIS_LINK', 'Domain Registration Operation', '1', '0= Do NOT add an "Order" or "Register" link.\r\n1= Add "Order" link and go to "orders" page, passing in domain name and setting "New Domain" to "Yes".\r\n2= Add "Register" link, going to your affiliiate link to register the domain. This option will open a new browser window to the registrar, and the original browser window will remain on this page.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'whois', 'B', 'WHOIS_ENABLED', 'WHOIS Enable (Visible)', '1', 'Determines if the WHOIS module is visible to the clients.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'clients', 'I', 'CLIENT_VIEW_PAGE_UPON_LOGIN', 'Client Default Page View Upon Login', '1', 'The page to show the client when they first log in.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'user', 'package', 'B', 'DISPLAY_ON_CONTACT_FORM', 'Display On Contact Form', '1', 'If "Yes", the Company Information in this section will be displayed on the "Contact Us" form,as well as used on invoices. If "No", the "Contact Us" form will be an email-only-form.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'domains', 'B', 'SHOW_PASSWORDS_TO_CLIENTS', 'Domain CP/FTP Show Passwords To Clients', '1', 'IF "Yes", clients can see their plaintext passwords for FTP and Control Panel access when viewing domain info. If "No", only admins can see the passwords.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'clients', 'I', 'CLIENT_LIST_DISPLAY', 'Optional Data Display for Listing', '1', 'Select the two-out-of-three columns that you wish displayed when viewing a list of clients.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'domains', 'B', 'DOMAINS_ENABLE', 'Domains Enable (Visible)', '1', 'Determines if the Domains module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'invoices', 'B', 'INVOICES_ENABLE', 'Invoices Enable (Visible)', '1', 'Determines if the Invoices module links / output is visible.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'summary', 'B', 'PRODUCT_SUMMARY_ENABLE', 'Summary- Display Active Products', '1', '"Yes" will display a summary of all products that are on an active order. "No" will not display. If "Orders Listing Show Prod. Description" in the "orders" section is set to "Yes", then the description will show on the display, otherwise the product name will be shown.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'operation', 'B', 'MAIL_USE_CUSTOM_SUBJECT', 'Email Contact Client: Use Custom Subject', '1', '"No" will use the default subject line of "sitename- Client Contact Message" on emails sent using the [eMail Client] form. "Yes" will use the subject that you entered on the form instead.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'summary', 'B', 'SUMMARY_INVOICES_BY_TYPE', 'Summary: Display Invoices By Billing Cycle', '1', 'If "Yes", invoices will be listed in columnar format, with the amounts broken out by status and billing cycle.  If "No", the default is to lump all billing cycles into one column.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_SAVE_DIR', 'MySQL Backup- Save Directory', 'c:/php/temp', 'Directory on webserver to save mySQL dump file to when the "save to webserver" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_FROM_NAME', 'MySQL Backup- Email From Name', 'phpCOIN', 'The name of the person that the email is from when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_FROM_ADDRESS', 'MySQL Backup- Email From Address', 'webserver@%DOMAINNAME%', 'The email address of the person that the email is from when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_TO_NAME', 'MySQL Backup- Email To Name', 'Recipient Name', 'The name of the person that the email is to when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_TO_ADDRESS', 'MySQL Backup- Email To Address', 'support@%DOMAINNAME%', 'The email address of the person that the email is to when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_SUBJECT', 'MySQL Backup- Email Subject', 'phpCOIN Database Backup Attached', 'Subject line of email sent when "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'S', 'MYSQL_BACKUP_EMAIL_BODY', 'MySQL Backup- Email Body', 'A MySQL dump of your phpCOIN database is attached to this email.', 'The message body when the "Email to me" backup option is chosen.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'backup', 'I', 'MYSQL_BACKUP_EMAIL_PRIORITY', 'MySQL Backup- Email Priority', '3', 'Priority of message when "email to me" backup option is chosen. 1 is "Urgent", 3 is "Normal".');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'user', 'package', 'S', 'CO_INFO_11_TOLL_FREE', 'Company Info 11- Toll Free Number', '(877) 842-8434', 'Global scope variable, currently used in footer.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'user', 'package', 'S', 'CO_INFO_12_TAGLINE', 'Company Info 12- TagLine', 'Hosting For The Little Guy', 'Text of a "tagline" that will appear on invoices, and in the site footer');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'B', 'ORDER_AUTO_CREATE_INVOICE', 'Invoice: Auto-Create From Order', '1', '"Yes" will auto-create an invoice with the default terms, due dates, etc. everytime a product is ordered. "No" will NOT create the invoice.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'S', 'AUTO_INV_STATUS', 'Invoice: Default Status', 'due', 'Default status of invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'S', 'AUTO_INV_DELIVERY', 'Invoice: Default Delivery Method', 'email', 'Default delivery method for invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'I', 'AUTO_INVC_BILL_CYCLE', 'Invoice: Default Billing Cycle', '1', 'Default billing cycle for invoices auto-created by the order module.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'B', 'AUTO_INV_DELIVERED', 'Invoice: Flag as Delivered', '1', 'Should the invoice "delivered" flag be set to delivered?');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'orders', 'B', 'ORDER_AUTO_PAY_INVOICE', 'Invoice: Auto-Pay From Order', '1', 'Auto Pay invoice on successful buy return. Normally YES, this MUST be turned OFF if you have the IPN add-on installed');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'B', 'HELPDESK_AUTO_IMPORT_ENABLE', 'Helpdesk: Auto-import enable', '1', 'If "Yes", helpdesk_auto.php will connect to a POP or IMAP box and attempt to create helpdesk tickets from any messages found.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_SERVER', 'Helpdesk: Auto-import server', 'mail.%DOMAINNAME%', 'Name of the email server to connect to for auto-importing helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_TYPE', 'Helpdesk: Auto-import protocol', '/imap:143/notls', 'Protocol and port to connect. "/imap:143" seems to work better than "/pop:110". You may also need to try /:143/IMAP/notls or /:110/POP/notls depending on your mailserver');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_USERID', 'Helpdesk: Auto-import mailbox', 'support@%DOMAINNAME%', 'The mailbox to connect to for helpdesk auto-import.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_PASSWORD', 'Helpdesk: Auto-import password', 'password', 'Password for the email box that will be checked automaticaly.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'B', 'HELPDESK_AUTO_IMPORT_DELETE_IMPORTED_MESSAGES', 'Helpdesk: Auto-import delete imported', '0', '"Yes" will delete any imported messages from the mailserver. "No" will leave all messages on the server, imported or not.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_CATEGORY', 'Helpdesk: Auto-import category', 'General', 'Default "category" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_PRIORITY', 'Helpdesk: Auto-import priority', 'Medium Priority', 'Default "priority" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'helpdesk', 'S', 'HELPDESK_AUTO_IMPORT_DEFAULT_STATUS', 'Helpdesk: Auto-import status', 'Awaiting Support', 'Default "status" for auto-imported helpdesk messages.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'operation', 'B', '_PKG_SAFE_EMAIL_ADDRESS', 'Safe Email Address', '0', 'If "No", emails sent from phpCOIN use the "Name <name@address>" format. Some mail servers have a problem with this, so setting this value to "Yes" means that emails will be sent as only <name@address> which every mailserver will accept.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'I', 'ORDERS_PROD_LIST_SIZE', 'Product list type and size', '1', 'If 0, products will be displayed as a radio list on the order form. Any non-zero value will use a select-list with that many rows visible.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'package', 'B', 'AUTOCHECK_UPDATES', 'Automatically Check For Updates', '1', 'If enabled, phpCOIN will check for new versions and bug-fixes each time you click the [Admin] button. This parameter enables phpCOIN to advise you when a new version or bug-fix is available, and provides a direct link to the actual download.  This feature uses an RSS feed, and does NOT send any information whatsoever to phpCOIN.com');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'package', 'R', 'PAYLINK_EXCHANGE_RATE', 'Exchange Rate For PayLinks', '0', 'If you show your prices in one curency and collect payment in another, enter the exchange rate here. If you do not use different currencies, leave this as either 1 or 0');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'operation', 'B', '_debug_queries', 'Show Debug Info', '0', 'Shows or hides debug info for MySQL queries and server loads at page bottom');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'B', 'ORDERS_ITEMS_SUB-LIST', 'Group products with heading', '1', 'If items are displayed on order form by radio list, setting this ON will "group" 	the products by the first word in the product display, with that word also used as a group title. This means you can group products by name, description or price.');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'admin', 'B', 'DisplayType', 'Admin Menu: Display as List', '1', 'Displays the Admin Menu as default "button" table or as new "list" format');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'operation', 'B', 'EMAIL_AS_HTML', 'Email: Enable HTML email', '1', 'Enables sending emails as html email with attachments, or as plain ascii text');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'operation', 'B', 'ENABLE_QUICK_EDIT', 'Enable Quick-Edit Icons', '1', 'Enables a quick-access icon for editing parameters and page text, rather than forcing admin to goto Admin and select proper options');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'B', 'ORDER_EDIT_CLIENT', 'Allow editing client info on re-order', '0', 'YES will allow an existing client to edit their contact info when placing a new order. NO will display their contact info without allowing editing');
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'common', 'orders', 'I', 'ORDERS_PROD_DISPLAY_SEQUENCE', 'Orders- Products Display Sequence', 1, 'What to display on the Products List shown to clients when ordering.');
DELETE FROM %PREFIX%parameters WHERE parm_name='ORDERS_PROD_LIST_NAME_SHOW';
DELETE FROM %PREFIX%parameters WHERE parm_name='INVC_ACOPY_DELAY_ENABLE';
INSERT INTO %PREFIX%parameters (`parm_id`, `parm_group`, `parm_group_sub`, `parm_type`, `parm_name`, `parm_desc`, `parm_value`, `parm_notes`) VALUES ('', 'automation', 'invoices', 'B', 'INVC_ACOPY_DELAY_ENABLE', 'Invoices: Delay auto-copy', 1, 'Waits to auto-copy invoices until x days beforre the next due date. Prevents a pending invoice from being on file for months at a time.');
UPDATE %PREFIX%parameters SET parm_group='automation' WHERE parm_name='INVC_ACOPY_DAYS_OUT';
UPDATE %PREFIX%parameters SET parm_group='automation' WHERE parm_name='INVC_AUTO_UPDATE_ENABLE';
UPDATE %PREFIX%parameters SET parm_group='automation' WHERE parm_name='INVC_AUTO_COPY_ENABLE';
UPDATE %PREFIX%versions SET v_ver='v1.2.1', v_type='Upgrade';